&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&Scoped-define FRAME-NAME Dialog-Frame
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Dialog-Frame 
&IF DEFINED(UIB_is_Running) NE 0 &THEN
    DEFINE variable p-Devicename  AS CHAR    NO-UNDO initial "".              /* if "" then default printer           */
    DEFINE variable p-Filename    AS CHAR    NO-UNDO initial "".              /* file name */  
    DEFINE variable p-docname     AS CHAR    NO-UNDO initial "Test Preview".  /* if "" then p-Filename                */
    DEFINE variable PaperSize     AS INTEGER NO-UNDO initial 9.               /* 1-letter; 8-A3; 9-A4 */
    DEFINE variable p-Landscape   AS LOGICAL NO-UNDO initial false.     
    DEFINE variable p-Leftmargin  AS DECIMAL NO-UNDO INITIAL 0.0.             /* left margin (cm) from paper edge     */
    DEFINE variable p-Rightmargin AS DECIMAL NO-UNDO INITIAL 0.0 .            /* right margin (cm) from paper edge    */
    DEFINE variable p-fontsize    AS INTEGER NO-UNDO INITIAL 10.              /* pointsize for bodyfont               */
    DEFINE variable print-h-f     AS LOGICAL NO-UNDO INITIAL TRUE.            /* Print header and footer              */
    DEFINE variable num-copies    AS INTEGER NO-UNDO INITIAL 1. 
&ELSE
    DEFINE INPUT PARAMETER p-Devicename  AS CHAR    NO-UNDO.    /* if "" then default printer           */
    DEFINE INPUT PARAMETER p-Filename    AS CHAR    NO-UNDO.
    DEFINE INPUT PARAMETER p-docname     AS CHAR    NO-UNDO.    /* if "" then p-Filename                */
    DEFINE INPUT PARAMETER PaperSize     AS INTEGER NO-UNDO.    /* 1-letter; 8-A3; 9-A4 */
    DEFINE INPUT PARAMETER p-Landscape   AS LOGICAL NO-UNDO. 
    DEFINE INPUT PARAMETER p-Leftmargin  AS DECIMAL NO-UNDO.    /* left margin (cm) from paper edge     */
    DEFINE INPUT PARAMETER p-Rightmargin AS DECIMAL NO-UNDO.    /* right margin (cm) from paper edge    */
    DEFINE INPUT PARAMETER p-fontsize    AS INTEGER NO-UNDO.    /* pointsize for bodyfont               */
    DEFINE INPUT PARAMETER print-h-f     AS LOGICAL NO-UNDO.    /* Print header and footer              */
    DEFINE INPUT PARAMETER num-copies    AS INTEGER NO-UNDO. 

&ENDIF

def var print-mode as integer no-undo initial 2. /* 1 - normal; 2 paged i.e. Excel(Sheet) type */ 

{printfile.i}

&GLOB A 

DEF STREAM textfile.

def var hOldFont as integer no-undo.
def var hBodyFont as integer no-undo.
def var LineHeight as integer no-undo.
def var hHeaderFont as integer no-undo.
def var HeaderFontHeight as integer no-undo initial 0.
def var HeaderHeight as integer no-undo initial 0.
def var FooterHeight as integer no-undo initial 0.

def var maxH as integer no-undo.
def var maxW as integer no-undo.

def var hPrinterDC as integer no-undo.
def var PageHeight as integer no-undo.
def var PageWidth as integer no-undo.
def var LogPixX as integer no-undo.
def var LogPixY as integer no-undo.
def var PhyOffX as integer no-undo.
def var PhyOffY as integer no-undo.
def var PrintHeight as integer no-undo.
def var PrintWidth as integer no-undo.
def var TextWidth as integer no-undo.
def var MarginLeftPix as integer no-undo initial 0.
def var MarginRightPix as integer no-undo initial 0.

def var hScreenDC as integer no-undo.
def var ScrLogPixY as integer no-undo.
def var ScrLogPixX as integer no-undo.

def var hMemoryDC as integer no-undo.
def var hMemoryBMP as integer no-undo.
def var hOldBMP as integer no-undo.
def var OldBkMode as integer no-undo.
def var OldTextColor as integer no-undo.

def var XRatio as decimal no-undo.
def var YRatio as decimal no-undo.

def var CurrentY as integer no-undo.

def var is-right-page as logical initial false no-undo. /* flag for next column on current page */ 

def var preview-page as integer no-undo initial 1.
def var preview-column as integer no-undo initial 1.
def var max-page as integer no-undo initial 1.
def var max-column as integer no-undo initial 0.

def var is-first as logical no-undo initial true.  /* flag for first calling of PreviewPage procedure */

PROCEDURE GetDC EXTERNAL "user32" :
  DEFINE INPUT  PARAMETER hwnd AS long.
  DEFINE RETURN PARAMETER hdc  AS long.
END PROCEDURE.

PROCEDURE ReleaseDC EXTERNAL "user32" :
  DEFINE INPUT  PARAMETER hwnd AS long.
  DEFINE INPUT  PARAMETER hdc  AS long.
  DEFINE RETURN PARAMETER ok   AS long.
END PROCEDURE.

PROCEDURE CreateCompatibleDC EXTERNAL "gdi32":
    define input parameter hDC as long.     /* handle to device context */
    define return parameter hCDC as long.   /* handle to a compatible memory device context */
END.

PROCEDURE CreateCompatibleBitmap EXTERNAL "gdi32":
    define input parameter hDC as long.     /* handle to device context */
    define input parameter nWidth as long.  /* width of bitmap, in pixels  */
    define input parameter nHeight as long. /* height of bitmap, in pixels  */
    define return parameter hBMP as long.   /* handle to the bitmap */
END.

&GLOB TRANSPARENT     1
&GLOB OPAQUE          2

PROCEDURE SetBkMode{&A} EXTERNAL "gdi32":
    define input parameter hDC as long.      /* handle to device context */
    define input parameter Flag as long.     /* mode flag */
    define return parameter oldFlag as long. /* prev mode flag */
END.

PROCEDURE SetTextColor{&A} EXTERNAL "gdi32":
    define input parameter hDC as long.      /* handle to device context */
    define input parameter iColor as long.     /* new color */
    define return parameter oldColor as long. /* old color */
END.

&GLOB WHITENESS 16711778

PROCEDURE PatBlt{&A} EXTERNAL "gdi32":
    define input parameter hDC as long.         /* handle to device context */
    define input parameter nXLeft as long.      /* x-coord. of upper-left corner of rect. to be filled */
    define input parameter nYLeft as long.      /* y-coord. of upper-left corner of rect. to be filled */
    define input parameter nWidth as long.      /* width of rectangle to be filled */
    define input parameter nHeight as long.     /* height of rectangle to be filled */
    define input parameter dwRop as long.       /* raster operation code */
    define return parameter RetValue as long.   /* must be <> 0 */
END. 

&GLOB SRCCOPY 13369376
PROCEDURE  StretchBlt{&A} EXTERNAL "gdi32":
    define input parameter hdcDest as long.         /* handle of destination device context  */
    define input parameter nXOriginDest as long.    /* x-coordinate of upper-left corner of dest. rect.  */
    define input parameter nYOriginDest as long.    /* y-coordinate of upper-left corner of dest. rect.  */
    define input parameter nWidthDest as long.      /* width of destination rectangle  */
    define input parameter nHeightDest as long.     /* height of destination rectangle  */
    define input parameter hdcSrc as long.          /* handle of source device context  */
    define input parameter nXOriginSrc as long.     /* x-coordinate of upper-left corner of source rectangle  */
    define input parameter nYOriginSrc as long.     /* y-coordinate of upper-left corner of source rectangle  */
    define input parameter nWidthSrc as long.       /* width of source rectangle  */
    define input parameter nHeightSrc as long.      /* height of source rectangle  */
    define input parameter dwRop as long.           /* raster operation code  */
    define return parameter RetValue as short.      /* must be <> 0 */
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE DIALOG-BOX
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME Dialog-Frame

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS r-page b-refresh b-first b-prev b-next ~
b-last fi-pages fi-columns 
&Scoped-Define DISPLAYED-OBJECTS fi-pages fi-columns 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define a dialog box                                                  */

/* Definitions of the field level widgets                               */
DEFINE BUTTON b-first 
     LABEL "|<" 
     SIZE 8 BY .95.

DEFINE BUTTON b-last 
     LABEL ">|" 
     SIZE 8 BY .95.

DEFINE BUTTON b-next 
     LABEL ">>" 
     SIZE 8 BY .95.

DEFINE BUTTON b-prev 
     LABEL "<<" 
     SIZE 8 BY .95.

DEFINE BUTTON b-refresh 
     LABEL "..." 
     SIZE 8 BY .95.

DEFINE VARIABLE fi-columns AS CHARACTER FORMAT "X(256)":U 
      VIEW-AS TEXT 
     SIZE 9 BY .57
     FGCOLOR 12  NO-UNDO.

DEFINE VARIABLE fi-pages AS CHARACTER FORMAT "X(256)":U 
     LABEL "Page" 
      VIEW-AS TEXT 
     SIZE 9.2 BY .57
     FGCOLOR 9  NO-UNDO.

DEFINE RECTANGLE r-page
     EDGE-PIXELS 1 GRAPHIC-EDGE  NO-FILL 
     SIZE 147 BY 24.76.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME Dialog-Frame
     b-refresh AT ROW 26 COL 30
     b-first AT ROW 26 COL 39
     b-prev AT ROW 26 COL 48
     b-next AT ROW 26 COL 57
     b-last AT ROW 26 COL 66
     fi-pages AT ROW 26.14 COL 9.8 COLON-ALIGNED
     fi-columns AT ROW 26.14 COL 19 COLON-ALIGNED NO-LABEL
     r-page AT ROW 1 COL 1
     SPACE(0.39) SKIP(1.23)
    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 
         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 
         TITLE "<insert dialog title>".


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: DIALOG-BOX
   Allow: Basic,Browse,DB-Fields,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR DIALOG-BOX Dialog-Frame
                                                                        */
ASSIGN 
       FRAME Dialog-Frame:SCROLLABLE       = FALSE
       FRAME Dialog-Frame:HIDDEN           = TRUE.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME Dialog-Frame
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Dialog-Frame Dialog-Frame
ON WINDOW-CLOSE OF FRAME Dialog-Frame /* <insert dialog title> */
DO:
  APPLY "END-ERROR":U TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME b-first
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL b-first Dialog-Frame
ON CHOOSE OF b-first IN FRAME Dialog-Frame /* |< */
DO:
    
    if preview-page = 1 and preview-column = 1 then do:
        bell.
        return.
    end.
    else do:
        preview-page = 1.
        preview-column = 1.
        run PreviewPage.
    end.
    
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME b-last
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL b-last Dialog-Frame
ON CHOOSE OF b-last IN FRAME Dialog-Frame /* >| */
DO:
    
    if preview-page = max-page and preview-column = max-column then do:
        bell.
        return.
    end.
    else do:
        preview-page = max-page.
        preview-column = max-column.
        run PreviewPage.
    end.    
    
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME b-next
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL b-next Dialog-Frame
ON CHOOSE OF b-next IN FRAME Dialog-Frame /* >> */
DO:
    
    if preview-column < max-column then do:
        preview-column = preview-column + 1.
    end.
    else do:
        if preview-page < max-page then do:
            preview-column = 1.
            preview-page = preview-page + 1.            
        end.
        else do:
            bell.
            return.
        end.
    end.
    
    run PreviewPage.
    
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME b-prev
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL b-prev Dialog-Frame
ON CHOOSE OF b-prev IN FRAME Dialog-Frame /* << */
DO:
    if preview-column NE 1 then do:
        preview-column = preview-column - 1.
    end.
    else do:
        if preview-page NE 1 then do:
            preview-column = max-column.
            preview-page = preview-page - 1.            
        end.
        else do:
            bell.
            return.
        end.
    end.

    run PreviewPage.
    
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME b-refresh
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL b-refresh Dialog-Frame
ON CHOOSE OF b-refresh IN FRAME Dialog-Frame /* ... */
DO:
    run PreviewPage.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Dialog-Frame 


/* ***************************  Main Block  *************************** */

/* Parent the dialog-box to the ACTIVE-WINDOW, if there is no parent.   */
IF VALID-HANDLE(ACTIVE-WINDOW) AND FRAME {&FRAME-NAME}:PARENT eq ?
THEN FRAME {&FRAME-NAME}:PARENT = ACTIVE-WINDOW.


/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  
  
    maxH = r-page:height-pixels.
    maxW = r-page:width-pixels.
    p-LeftMargin = p-LeftMargin / 2.54.
    p-RightMargin = p-RightMargin / 2.54.

    frame {&frame-name}:title = p-Docname + " - Preview".
    run PreviewPage.

    if max-column > 1 then 
        fi-columns:screen-value = "/" + string(max-column) + " cols.".  
  
    
  WAIT-FOR GO OF FRAME {&FRAME-NAME}.
END.
RUN disable_UI.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE create-font Dialog-Frame 
PROCEDURE create-font :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
define input parameter font-size as integer no-undo.
define input parameter font-name as character no-undo.
define input parameter italics as integer no-undo.
define input parameter under-line as integer no-undo.
define input parameter strikeout as integer no-undo.
define output parameter hFont as integer no-undo.

def var emheight as integer no-undo.

  RUN MulDiv (font-size, LogPixY, 72, OUTPUT emheight).
  emheight = 0 - emheight.
  RUN CreateFontA ( emheight,
                    0,
                    0,
                    0,
                    400,
                    italics,
                    under-line,
                    strikeout,
                    {&ANSI_CHARSET},
                    {&OUT_DEFAULT_PRECIS},
                    {&CLIP_DEFAULT_PRECIS},
                    {&PROOF_QUALITY},
                    {&VARIABLE_PITCH} + {&FF_DONTCARE},
                    font-name,
                    OUTPUT hFont).


END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI Dialog-Frame  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME Dialog-Frame.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI Dialog-Frame  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY fi-pages fi-columns 
      WITH FRAME Dialog-Frame.
  ENABLE r-page b-refresh b-first b-prev b-next b-last fi-pages fi-columns 
      WITH FRAME Dialog-Frame.
  VIEW FRAME Dialog-Frame.
  {&OPEN-BROWSERS-IN-QUERY-Dialog-Frame}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE get-hPrinterDC Dialog-Frame 
PROCEDURE get-hPrinterDC :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
define output parameter hDC as integer no-undo.

def var ReturnValue as integer no-undo.

    DEF VAR devicespecs      AS CHAR    NO-UNDO.
    DEF VAR lpdocname        AS MEMPTR  NO-UNDO.
    DEF VAR lpdocinfo        AS MEMPTR  NO-UNDO.
    DEF VAR JobID            AS INTEGER NO-UNDO.
    DEF VAR lpDefaultDevmode AS MEMPTR  NO-UNDO.
    DEF VAR lpDevmode        AS MEMPTR  NO-UNDO.


    /* no devicename specified? Then use default printer */
    IF p-devicename = "" THEN DO:
       devicespecs = FILL("x", 255).
       RUN GetProfileStringA ("windows":U,
                              "device":U,
                              "-unknown-,,":U,
                              OUTPUT devicespecs,
                              LENGTH(devicespecs),
                              OUTPUT ReturnValue).
       p-devicename = ENTRY(1, devicespecs).
    END.
    IF p-devicename="-unknown-":U THEN DO:
       RETURN.
    END.
    
    IF p-docname="" or p-docname=? THEN
       p-docname=p-Filename.

    SET-SIZE(lpdocname)     = LENGTH(p-docname) + 1.
    PUT-STRING(lpdocname,1) = p-docname.
    SET-SIZE(lpdocinfo)     = 12.
    PUT-LONG(lpdocinfo, 1)  = GET-SIZE(lpdocinfo).
    PUT-LONG(lpdocinfo, 5)  = GET-POINTER-VALUE(lpdocname).
    PUT-LONG(lpdocinfo, 9)  = 0.


    /* ask for the size of the devmode structure: */
    RUN DocumentPropertiesA (0, 0,
                                p-devicename,
                                0,
                                0,
                                0,
                                output ReturnValue).
    SET-SIZE(lpDefaultDevMode) = ReturnValue.
    SET-SIZE(lpDevMode)        = ReturnValue.


    /* get the default contents of the devmode structure: */
    RUN DocumentPropertiesA (0, 0,
                                p-devicename,
                                GET-POINTER-VALUE(lpDefaultDevMode),
                                0,
                                {&DM_OUT_BUFFER},
                                output ReturnValue).
    /* specify what you want to change: */
    PUT-LONG (lpDefaultDevMode, {&CCHDEVICENAME} +  9) = {&DM_ORIENTATION} + {&DM_COPIES}.
    PUT-SHORT(lpDefaultDevMode, {&CCHDEVICENAME} + 23) = num-copies.

/* for size */
    PUT-LONG (lpDefaultDevMode, {&CCHDEVICENAME} +  9) = GET-LONG (lpDefaultDevMode, {&CCHDEVICENAME} +  9) +
                                                         {&DM_PAPERSIZE}.
    PUT-SHORT(lpDefaultDevMode, {&CCHDEVICENAME} + 15) = PaperSize. /* PAPER size  1-letter; 8-A3; 9-A4 */
/* end for size */    

    IF p-Landscape THEN
       PUT-SHORT(lpDefaultDevMode, {&CCHDEVICENAME} + 13) = {&DMORIENT_LANDSCAPE}.
    ELSE
       PUT-SHORT(lpDefaultDevMode, {&CCHDEVICENAME} + 13) = {&DMORIENT_PORTRAIT}.


    /* create a merged devmode: */
    RUN DocumentPropertiesA (0, 0,
                                p-devicename,
                                GET-POINTER-VALUE(lpDevMode),
                                GET-POINTER-VALUE(lpDefaultDevMode),
                                {&DM_IN_BUFFER} + {&DM_OUT_BUFFER},
                                output ReturnValue).

    RUN CreateDCA ("WINSPOOL":U,
                   p-devicename,
                   0,
                   GET-POINTER-VALUE(lpDevMode),
                   OUTPUT hDC).

    SET-SIZE(lpDefaultDevMode)    = 0.
    SET-SIZE(lpDevMode) = 0.
    SET-SIZE(lpdocinfo) = 0.
    SET-SIZE(lpdocname) = 0.


END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE GetBodyCharWidth Dialog-Frame 
PROCEDURE GetBodyCharWidth :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEFINE INPUT PARAMETER hDC AS INTEGER no-undo.
DEFINE OUTPUT PARAMETER p-LH AS INTEGER no-undo.

def var ReturnValue as integer no-undo.
    
    DEF VAR lpTm AS MEMPTR NO-UNDO.
    SET-SIZE(lpTM)= 15 * 4 + 5.
    
    RUN GetTextMetricsA (INPUT  hDC,
                         INPUT  GET-POINTER-VALUE(lpTM),
                         OUTPUT ReturnValue).
    p-LH = GET-LONG(lpTM, 21).
    SET-SIZE(lpTM)=0.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE GetLineHeight Dialog-Frame 
PROCEDURE GetLineHeight :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
define input parameter hDC as integer no-undo.
DEFINE OUTPUT PARAMETER p-LH AS INTEGER no-undo.

def var ReturnValue as integer no-undo.

    DEF VAR lpTm AS MEMPTR NO-UNDO.
    SET-SIZE(lpTM)= 15 * 4 + 5.
    RUN GetTextMetricsA (INPUT  hDC,
                         INPUT  GET-POINTER-VALUE(lpTM),
                         OUTPUT ReturnValue).
    p-LH = GET-LONG(lpTM, 1).
    SET-SIZE(lpTM)=0.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE HorizontalLine Dialog-Frame 
PROCEDURE HorizontalLine :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEFINE INPUT PARAMETER hDC AS INTEGER NO-UNDO.
DEFINE INPUT PARAMETER Y   AS INTEGER NO-UNDO.

def var ReturnValue as integer no-undo.

   RUN MoveToEx(hDC, MarginLeftPix, Y, 0, OUTPUT ReturnValue).
   RUN LineTo  (hDC, MarginLeftPix + TextWidth, Y, OUTPUT ReturnValue).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE PreviewPage Dialog-Frame 
PROCEDURE PreviewPage :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
def var is-ok as logical no-undo.
def var result as integer no-undo.
def var emheight as integer no-undo.
def var k as decimal initial .5 no-undo.


    run get-hPrinterDC(output hPrinterDC).
    
    if hPrinterDC = 0 then do:
        message "Can't create Printer DC"
                view-as alert-box
                error.
        return.        
    end.

    RUN GetDeviceCaps (hPrinterDC, {&LOGPIXELSY}, OUTPUT LogPixY).
    RUN GetDeviceCaps (hPrinterDC, {&LOGPIXELSX}, OUTPUT LogPixX).

    RUN GetDeviceCaps (hPrinterDC, {&PHYSICALOFFSETX}, OUTPUT PhyOffX).
    RUN GetDeviceCaps (hPrinterDC, {&PHYSICALOFFSETY}, OUTPUT PhyOffY).

    RUN GetDeviceCaps (hPrinterDC, {&PHYSICALWIDTH}, OUTPUT PageWidth).
    RUN GetDeviceCaps (hPrinterDC, {&PHYSICALHEIGHT}, OUTPUT PageHeight).

    RUN GetDeviceCaps (hPrinterDC, {&VERTRES}, OUTPUT PrintHeight).
    RUN GetDeviceCaps (hPrinterDC, {&HORZRES}, OUTPUT PrintWidth).

    run GetDC (frame {&frame-name}:HWND,
                        output hScreenDC).
    RUN GetDeviceCaps (hScreenDC, {&LOGPIXELSY}, OUTPUT ScrLogPixY).
    RUN GetDeviceCaps (hScreenDC, {&LOGPIXELSX}, OUTPUT ScrLogPixX).
    
    XRatio = ScrLogPixX / LogPixX.
    YRatio = ScrLogPixY / LogPixY.    
    
    MarginLeftPix = max(p-Leftmargin * LogPixX - PhyOffX,0).
    MarginRightPix = max(p-Rightmargin * LogPixX - (PageWidth - PrintWidth - PhyOffX),0).
    
    TextWidth = PrintWidth - MarginLeftPix - MarginRightPix.
    
    k = min(maxW / (PageWidth * XRatio),
            maxH / (PageHeight * YRatio)).
                    
    XRatio = k * XRatio.
    YRatio = k * YRatio.    
    if is-first then do:
        r-page:width-pixels = integer(PageWidth * XRatio) no-error.
        r-page:height-pixels = integer(PageHeight * YRatio)  no-error.
        frame {&frame-name}:width-pixels = max(315,frame {&frame-name}:width-pixels - (maxW - r-page:width-pixels)) no-error.
    end.
    
    run CreateCompatibleDC(hPrinterDC, output hMemoryDC).
    run CreateCompatibleBitmap(hMemoryDC,PrintWidth,PrintHeight, output hMemoryBMP).
    run SelectObject(hMemoryDC,hMemoryBMP,output hOldBMP). 
    run SetBkMode(hMemoryDC,{&TRANSPARENT},output OldBkMode).

    run SetTextColor(hMemoryDC,0,output OldTextColor).
    
    run PatBlt(hMemoryDC,0,0,PrintWidth,PrintHeight,{&WHITENESS},output result).
    
    CurrentY = 0.
    if print-h-f then do:
        run create-font(7,"Arial Cyr",1,0,0,output hHeaderFont).
        IF hHeaderFont<>0 THEN
           RUN SelectObject(hMemoryDC, hHeaderFont, OUTPUT hOldFont).
        RUN GetLineHeight(hMemoryDC,OUTPUT HeaderFontHeight).
        run PrintHeader(hMemoryDC).
        run PrintFooter(hMemoryDC).
    end. 
    
    run create-font(p-fontsize,"Courier New Cyr",0,0,0,output hBodyFont).
    IF hOldFont <> 0 
        THEN
            RUN SelectObject(hMemoryDC, hBodyFont, OUTPUT hHeaderFont).
        ELSE 
            RUN SelectObject(hMemoryDC, hBodyFont, OUTPUT hOldFont).
        
    RUN GetLineHeight(hMemoryDC,OUTPUT LineHeight).

    run PrintPage(hMemoryDC,preview-page,preview-column).

    RUN SelectObject(hMemoryDC, hOldFont, OUTPUT result).
    
    if not is-first then do:
        session:set-wait-state("general":U).
        run StretchBlt(hScreenDC,
                       integer(PhyOffX * XRatio),
                       integer(PhyOffY * YRatio),
                       integer(PrintWidth * XRatio),
                       integer(PrintHeight * YRatio),
                       hMemoryDC,
                       0,
                       0,
                       PrintWidth,
                       PrintHeight,
                       {&SRCCOPY},
                       output result).
        session:set-wait-state("").
    end.
    
    

/* cleaning  up */ 
    if hHeaderFont <> 0 then
        run DeleteObject(hHeaderFont,output result).
    
    run DeleteObject(hBodyFont,output result).
    run SelectObject(hMemoryDC,hOldBMP,output result).
    run DeleteDC(hMemoryDC,output result).
    run DeleteObject(hMemoryBMP,output result).
    RUN DeleteDC (hPrinterDC, OUTPUT result).
    hPrinterDC = 0.
    run ReleaseDC (frame {&frame-name}:HWND,
                           hScreenDC,
                           output result). 
                           
    if result = 0 then do:
        message "Error releasing ScreenDC" 
                view-as alert-box
                warning.
    end.

    if is-first 
        then
            fi-pages:screen-value = "0 of " +
                                    string(max-page * max-column).
        else
            fi-pages:screen-value = string(preview-column + (preview-page - 1) * max-column) + 
                                    " of " +
                                    string(max-page * max-column).
                                    
    is-first = false.
    
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE PrintFooter Dialog-Frame 
PROCEDURE PrintFooter :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
define input parameter hDC as integer no-undo.

def var ReturnValue as integer no-undo.

  RUN PrintInformation ( hDC,
                         PrintHeight,
                         {&TA_BOTTOM},
                         'Date ' + STRING(TODAY, "99/99/9999"),
                         'Time ' + STRING(TIME, "HH:MM:SS"),
                         'Page ' + STRING(preview-page) + (if print-mode = 2 then "." + string(preview-column) else "" )).
  
  RUN HorizontalLine(hDC,PrintHeight - HeaderFontHeight - 7).
  FooterHeight = HeaderFontHeight + 12.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE PrintHeader Dialog-Frame 
PROCEDURE PrintHeader :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
define input parameter hDC as integer no-undo.

def var ReturnValue as integer no-undo.
  
  IF hHeaderFont<>0 THEN
     RUN SelectObject(hDC, hHeaderFont, OUTPUT ReturnValue).

  RUN PrintInformation ( hDC,
                         0,
                         {&TA_TOP},
                         "",
                         "",
                         p-docname).
  RUN HorizontalLine(hDC,HeaderFontHeight + 5).
  HeaderHeight = HeaderFontHeight + 10.
  CurrentY = HeaderHeight.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE PrintInformation Dialog-Frame 
PROCEDURE PrintInformation :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEFINE INPUT PARAMETER hDC         AS INTEGER NO-UNDO.
DEFINE INPUT PARAMETER Y           AS INTEGER NO-UNDO.
DEFINE INPUT PARAMETER valign      AS INTEGER NO-UNDO.
DEFINE INPUT PARAMETER Left-Text   AS CHAR    NO-UNDO.
DEFINE INPUT PARAMETER Center-Text AS CHAR    NO-UNDO.
DEFINE INPUT PARAMETER Right-Text  AS CHAR    NO-UNDO.

define variable ReturnValue as integer no-undo.

  IF NOT (left-text="" or left-text=?) THEN DO:
     RUN SetTextAlign(hDC, valign + {&TA_LEFT}, OUTPUT ReturnValue).
     RUN TextOutA( hDC,
                   MarginLeftPix,
                   Y,
                   left-text,
                   LENGTH(left-text),
                   OUTPUT ReturnValue).
  END.

  IF NOT (center-text="" or center-text=?) THEN DO:
     RUN SetTextAlign(hDC, valign + {&TA_CENTER}, OUTPUT ReturnValue).
     RUN TextOutA( hDC,
                   INTEGER((MarginLeftPix + TextWidth) / 2),
                   Y,
                   center-text,
                   LENGTH(center-text),
                   OUTPUT ReturnValue).
  END.

  IF NOT (right-text="" or right-text=?) THEN DO:
     RUN SetTextAlign(hDC, valign + {&TA_RIGHT}, OUTPUT ReturnValue).
     RUN TextOutA( hDC,
                   MarginLeftPix + TextWidth,
                   Y,
                   right-text,
                   LENGTH(right-text),
                   OUTPUT ReturnValue).
  END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE PrintPage Dialog-Frame 
PROCEDURE PrintPage :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
define input parameter hDC as integer no-undo.
define input parameter print-page-no as integer no-undo.
define input parameter print-column-no as integer no-undo.


def var full-line as character no-undo.
def var textline as character no-undo.
def var result as integer no-undo.

def var page-no as integer initial 1 no-undo.    
def var column-no as integer initial 1 no-undo.    
def var chars-per-line as integer no-undo.
def var is-next-column as logical initial true no-undo.
def var start-pos as integer no-undo.
def var body-char-width as integer.

    RUN SetTextAlign(hDC,{&TA_LEFT}, OUTPUT result).
    RUN GetBodyCharWidth(hDC,OUTPUT body-char-width).
    is-right-page = false.
    chars-per-line = truncate(TextWidth / body-char-width,0).
    do while is-next-column:  
        is-next-column = false.
        start-pos = 1 + (column-no - 1) * chars-per-line.
        INPUT STREAM textfile FROM VALUE(p-Filename).
            REPEAT:
                import STREAM textfile unformatted full-line.
                if length(full-line) > column-no * chars-per-line 
                      then is-next-column = true.
                textline = substring(full-line,start-pos,chars-per-line).
                if PrintHeight - FooterHeight LT CurrentY + LineHeight then do:
                    CurrentY = HeaderHeight.
                    page-no = page-no + 1.
                    max-page = max(max-page,page-no). 
                end.    
                if print-page-no = page-no and print-column-no = column-no then do: 
                    RUN TextOutA( hDC,
                                  MarginLeftPix, 
                                  CurrentY, 
                                  textline, 
                                  LENGTH(textline), 
                                  OUTPUT result).
                    if not is-right-page and is-next-column then 
                        is-right-page = true.
                end.    
                CurrentY = CurrentY + LineHeight.
            END.
        INPUT STREAM textfile CLOSE.
        max-column = max(max-column,column-no).
        column-no = column-no + 1.
        page-no = 1.
        CurrentY = HeaderHeight.
    end.  
    
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

