&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&Scoped-define FRAME-NAME Dialog-Frame
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Dialog-Frame 
&IF DEFINED(UIB_is_Running) NE 0 &THEN
    DEFINE variable p-Filename    AS CHAR    NO-UNDO initial "q-report\print.txt".
    DEFINE variable p-docname     AS CHAR    NO-UNDO initial "1234567890".      /* if "" then p-Filename                */
    DEFINE variable p-Devicename  AS CHAR    NO-UNDO initial "".      /* if "" then default printer           */
    DEFINE variable PaperSize     AS INTEGER NO-UNDO initial 9.       /* 9-4; 8-3; 1-Letter               */
    DEFINE variable p-Landscape   AS LOGICAL NO-UNDO initial false.   /* Orientation is Landscape or Portrait */
    DEFINE variable p-Leftmargin  AS DECIMAL NO-UNDO initial 2.0 .    /* left margin (cm) from paper edge     */
    DEFINE variable p-Rightmargin AS DECIMAL NO-UNDO initial 1.5.     /* right margin (cm) from paper edge    */
    DEFINE variable p-fontsize    AS INTEGER NO-UNDO initial 9.       /* pointsize for bodyfont               */
    DEFINE variable print-h-f     AS LOGICAL NO-UNDO initial true.    /* Print header and footer              */
    DEFINE variable print-code    AS LOGICAL NO-UNDO initial yes.     /* Print code              */
    DEFINE variable num-copies    AS INTEGER NO-UNDO initial 1.       /* num-copies               */
    DEFINE variable is-ok         AS LOGICAL NO-UNDO INITIAL false. 
&ELSE
    DEFINE INPUT PARAMETER p-Filename   AS CHAR NO-UNDO.
    DEFINE INPUT PARAMETER p-docname     AS CHAR    NO-UNDO.              /* if "" then p-Filename                */
    DEFINE INPUT-OUTPUT PARAMETER p-Devicename  AS CHAR    NO-UNDO.   /* if "" then default printer           */
    DEFINE INPUT-OUTPUT PARAMETER PaperSize     AS INTEGER NO-UNDO.   /* 9-4; 8-3; 1-Letter               */
    DEFINE INPUT-OUTPUT PARAMETER p-Landscape   AS LOGICAL NO-UNDO.   /* Orientation is Landscape or Portrait */
    DEFINE INPUT-OUTPUT PARAMETER p-Leftmargin  AS DECIMAL NO-UNDO.    /* left margin (cm) from paper edge     */
    DEFINE INPUT-OUTPUT PARAMETER p-Rightmargin AS DECIMAL NO-UNDO.  /* right margin (cm) from paper edge    */
    DEFINE INPUT-OUTPUT PARAMETER p-fontsize    AS INTEGER NO-UNDO.    /* pointsize for bodyfont               */
    DEFINE INPUT-OUTPUT PARAMETER print-h-f     AS LOGICAL NO-UNDO. /* Print header and footer              */
    DEFINE INPUT-OUTPUT PARAMETER print-code    AS LOGICAL NO-UNDO. /* Print code              */
    DEFINE INPUT-OUTPUT PARAMETER num-copies    AS INTEGER NO-UNDO. /* num-copies  */
    DEFINE       OUTPUT PARAMETER is-ok         AS LOGICAL NO-UNDO INITIAL false. 
&ENDIF

define variable pf-list as character initial "9,8,1".
define variable pf-names as character initial "A4 (210 x 297 mm),A3 (297 x 420 mm),Letter (8 1/2 x 11 in)".

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE DIALOG-BOX
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME Dialog-Frame

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS i-orient RECT-29 RECT-30 RECT-31 RECT-32 ~
b-preview cb-printer cb-size rs-orient fi-m-left fi-m-right t-h-f t-source ~
t-paged cb-font-size fi-num-copies b-OK b-cancel 
&Scoped-Define DISPLAYED-OBJECTS cb-printer cb-size rs-orient fi-m-left ~
fi-m-right t-h-f t-source t-paged cb-font-size fi-num-copies 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define a dialog box                                                  */

/* Definitions of the field level widgets                               */
DEFINE BUTTON b-cancel 
     LABEL "Cancel" 
     SIZE 10 BY 1.14
     BGCOLOR 8 .

DEFINE BUTTON b-OK 
     LABEL "OK" 
     SIZE 10 BY 1.14
     BGCOLOR 8 .

DEFINE BUTTON b-preview 
     LABEL "Preview" 
     SIZE 11 BY 1.14.

DEFINE VARIABLE cb-font-size AS INTEGER FORMAT ">9":U INITIAL 9 
     LABEL "Font size" 
     VIEW-AS COMBO-BOX INNER-LINES 5
     LIST-ITEMS "6","7","8","9","10","11","12" 
     SIZE 8 BY 1
     FONT 4 NO-UNDO.

DEFINE VARIABLE cb-printer AS CHARACTER FORMAT "X(256)":U 
     LABEL "Printer" 
     VIEW-AS COMBO-BOX INNER-LINES 5
     SIZE 57 BY 1 NO-UNDO.

DEFINE VARIABLE cb-size AS CHARACTER FORMAT "X(256)":U 
     LABEL "Format" 
     VIEW-AS COMBO-BOX INNER-LINES 5
     SIZE 22 BY 1 NO-UNDO.

DEFINE VARIABLE fi-m-left AS DECIMAL FORMAT "9.9 cm":U INITIAL 2 
     LABEL "Left" 
     VIEW-AS FILL-IN 
     SIZE 8 BY 1
     FONT 4 NO-UNDO.

DEFINE VARIABLE fi-m-right AS DECIMAL FORMAT "9.9 cm":U INITIAL 1.5 
     LABEL "Right" 
     VIEW-AS FILL-IN 
     SIZE 8 BY 1
     FONT 4 NO-UNDO.

DEFINE VARIABLE fi-num-copies AS INTEGER FORMAT ">>9":U INITIAL 1 
     LABEL "Num. copies" 
     VIEW-AS FILL-IN 
     SIZE 8 BY 1
     FONT 4 NO-UNDO.

DEFINE IMAGE i-orient
     FILENAME "images/o-port":U
     SIZE 7 BY 1.67.

DEFINE VARIABLE rs-orient AS CHARACTER 
     VIEW-AS RADIO-SET VERTICAL
     RADIO-BUTTONS 
          "Portrait", "port",
"Landscape", "land"
     SIZE 20 BY 1.91 NO-UNDO.

DEFINE RECTANGLE RECT-29
     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 
     SIZE 33 BY 4.52.

DEFINE RECTANGLE RECT-30
     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 
     SIZE 33 BY 2.14.

DEFINE RECTANGLE RECT-31
     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 
     SIZE 33 BY 5.71.

DEFINE RECTANGLE RECT-32
     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 
     SIZE 33 BY 2.62.

DEFINE VARIABLE t-h-f AS LOGICAL INITIAL no 
     LABEL "Print header and footer" 
     VIEW-AS TOGGLE-BOX
     SIZE 27 BY .81 NO-UNDO.

DEFINE VARIABLE t-paged AS LOGICAL INITIAL no 
     LABEL "Sheet like printing" 
     VIEW-AS TOGGLE-BOX
     SIZE 28 BY .81 NO-UNDO.

DEFINE VARIABLE t-source AS LOGICAL INITIAL no 
     LABEL "Procedure style" 
     VIEW-AS TOGGLE-BOX
     SIZE 27 BY .81 NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME Dialog-Frame
     b-preview AT ROW 8.62 COL 36
     cb-printer AT ROW 1.24 COL 10 COLON-ALIGNED
     cb-size AT ROW 3.14 COL 10 COLON-ALIGNED
     rs-orient AT ROW 5.05 COL 13 NO-LABEL
     fi-m-left AT ROW 8.14 COL 7 COLON-ALIGNED
     fi-m-right AT ROW 8.14 COL 24 COLON-ALIGNED
     t-h-f AT ROW 3.14 COL 38
     t-source AT ROW 4.1 COL 38
     t-paged AT ROW 5.05 COL 38
     cb-font-size AT ROW 6 COL 56 COLON-ALIGNED
     fi-num-copies AT ROW 7.19 COL 56 COLON-ALIGNED
     b-OK AT ROW 8.62 COL 48
     b-cancel AT ROW 8.62 COL 59
     i-orient AT ROW 5.29 COL 5
     RECT-29 AT ROW 2.67 COL 2
     RECT-30 AT ROW 7.67 COL 2
     RECT-31 AT ROW 2.67 COL 36
     RECT-32 AT ROW 4.57 COL 2
     "Other settings" VIEW-AS TEXT
          SIZE 14 BY .62 AT ROW 2.43 COL 37
     "Margins" VIEW-AS TEXT
          SIZE 8 BY .62 AT ROW 7.43 COL 3
     "Paper" VIEW-AS TEXT
          SIZE 6 BY .62 AT ROW 2.43 COL 3
     "Orientation" VIEW-AS TEXT
          SIZE 11 BY .62 AT ROW 4.33 COL 3
     SPACE(55.99) SKIP(5.14)
    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 
         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 
         TITLE "Print Setup"
         DEFAULT-BUTTON b-OK CANCEL-BUTTON b-cancel.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: DIALOG-BOX
   Allow: Basic,Browse,DB-Fields,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR DIALOG-BOX Dialog-Frame
   Custom                                                               */
ASSIGN 
       FRAME Dialog-Frame:SCROLLABLE       = FALSE
       FRAME Dialog-Frame:HIDDEN           = TRUE.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME Dialog-Frame
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Dialog-Frame Dialog-Frame
ON WINDOW-CLOSE OF FRAME Dialog-Frame /* Print Setup */
DO:
  APPLY "END-ERROR":U TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME b-cancel
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL b-cancel Dialog-Frame
ON CHOOSE OF b-cancel IN FRAME Dialog-Frame /* Cancel */
DO:
    apply "go":U to frame {&frame-name}.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME b-OK
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL b-OK Dialog-Frame
ON CHOOSE OF b-OK IN FRAME Dialog-Frame /* OK */
DO:
  
    assign cb-font-size fi-m-left fi-m-right rs-orient t-h-f t-source t-paged fi-num-copies cb-printer cb-size.
    p-Devicename = cb-printer.
    p-Landscape = rs-orient = "land".
    p-Leftmargin = fi-m-left. 
    p-Rightmargin = fi-m-right.
    p-fontsize = cb-font-size.   
    print-h-f = t-h-f.
    PaperSize = integer(entry(max(1,lookup(cb-size,pf-names)),pf-list)).
  

    
    if t-paged 
        then print-code = ?.
        else print-code = t-source.   
    num-copies = fi-num-copies.
    if num-copies < 1 then num-copies = 1.
    is-ok = true.
    apply "go":U to frame {&frame-name}.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME b-preview
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL b-preview Dialog-Frame
ON CHOOSE OF b-preview IN FRAME Dialog-Frame /* Preview */
DO:
    assign cb-font-size fi-m-left fi-m-right rs-orient t-h-f t-source t-paged fi-num-copies cb-printer cb-size.

/*p-Devicename  /* if "" then default printer           */
 * p-Filename   
 * p-docname     /* if "" then p-Filename                */
 * PaperSize     /* 1-letter; 8-A3; 9-A4 */
 * p-Landscape  
 * p-Leftmargin  /* left margin (cm) from paper edge     */
 * p-Rightmargin /* right margin (cm) from paper edge    */
 * p-fontsize    /* pointsize for bodyfont               */
 * print-h-f     /* Print header and footer              */
 * num-copies*/     

    run preview-d.w (cb-printer,
                    p-filename,
                    p-docname,
                    integer(entry(max(1,lookup(cb-size,pf-names)),pf-list)),
                    rs-orient = "land",
                    fi-m-left,
                    fi-m-right,
                    cb-font-size,
                    t-h-f,
                    (if fi-num-copies < 1 then 1 else fi-num-copies)
                    ).
    

/*    p-Devicename = cb-printer.
 *     p-Landscape = rs-orient = "land".
 *     p-Leftmargin = fi-m-left. 
 *     p-Rightmargin = fi-m-right.
 *     p-fontsize = cb-font-size.   
 *     print-h-f = t-h-f.
 *     PaperSize = integer(entry(max(1,lookup(cb-size,pf-names)),pf-list)).
 *     if t-paged 
 *         then print-code = ?.
 *         else print-code = t-source.   
 *     num-copies = fi-num-copies.
 *     if num-copies < 1 then num-copies = 1.*/


  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME rs-orient
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL rs-orient Dialog-Frame
ON VALUE-CHANGED OF rs-orient IN FRAME Dialog-Frame
DO:
    assign {&self-name}.
    i-orient:load-image("images\o-" + {&self-name}).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME t-paged
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL t-paged Dialog-Frame
ON VALUE-CHANGED OF t-paged IN FRAME Dialog-Frame /* Sheet like printing */
DO:
    t-source:sensitive = not self:checked.
    if self:checked then t-source:checked = false.
    b-preview:sensitive = self:checked.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Dialog-Frame 


/* ***************************  Main Block  *************************** */

/* Parent the dialog-box to the ACTIVE-WINDOW, if there is no parent.   */
IF VALID-HANDLE(ACTIVE-WINDOW) AND FRAME {&FRAME-NAME}:PARENT eq ?
THEN FRAME {&FRAME-NAME}:PARENT = ACTIVE-WINDOW.


/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  
  run init-window.
  
  WAIT-FOR GO OF FRAME {&FRAME-NAME}.
END.
RUN disable_UI.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI Dialog-Frame  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME Dialog-Frame.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI Dialog-Frame  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY cb-printer cb-size rs-orient fi-m-left fi-m-right t-h-f t-source 
          t-paged cb-font-size fi-num-copies 
      WITH FRAME Dialog-Frame.
  ENABLE i-orient RECT-29 RECT-30 RECT-31 RECT-32 b-preview cb-printer cb-size 
         rs-orient fi-m-left fi-m-right t-h-f t-source t-paged cb-font-size 
         fi-num-copies b-OK b-cancel 
      WITH FRAME Dialog-Frame.
  VIEW FRAME Dialog-Frame.
  {&OPEN-BROWSERS-IN-QUERY-Dialog-Frame}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE init-window Dialog-Frame 
PROCEDURE init-window :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

     rs-orient:screen-value in frame {&frame-name}= if p-Landscape then "land" else "port".
     apply "value-changed":U to rs-orient.
     fi-m-left:screen-value = string(p-Leftmargin). 
     fi-m-right:screen-value = string(p-Rightmargin).
     cb-font-size:screen-value = string(p-fontsize).   
     t-h-f:checked = print-h-f.
     if print-code = ? then do:
        t-paged:checked = true.
     end.
     else do:
        t-source:checked = print-code. 
     end.   
     apply "value-changed":U to t-paged.  
     
     fi-num-copies:screen-value = string(num-copies). 
     run enum-printers.p(cb-printer:handle).
     cb-printer:screen-value = p-Devicename no-error.
     
     cb-size:list-items = pf-names.
     run cb-drop-width.p(input cb-size:handle).
     cb-size:screen-value = entry(max(1,lookup(string(PaperSize),pf-list)),pf-names).
     
      
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

