/* =================================================================
   file    : printfile.i
   purpose : WIN32 API declarations for printfile.p
   by      : Jurjen Dijkstra
             mailto:jurjen@global-shared.com
             see also http://www.global-shared.com/api
   ================================================================= */

  &GLOB HORZRES 8
  &GLOB VERTRES 10
  &GLOB LOGPIXELSX 88
  &GLOB LOGPIXELSY 90
  &GLOB PHYSICALWIDTH 110
  &GLOB PHYSICALHEIGHT 111
  &GLOB PHYSICALOFFSETX 112
  &GLOB PHYSICALOFFSETY 113

  &GLOB TA_TOP 0
  &GLOB TA_BOTTOM 8
  &GLOB TA_LEFT 0
  &GLOB TA_CENTER 6
  &GLOB TA_RIGHT 2

  &GLOB ANSI_CHARSET 0
  &GLOB OUT_DEFAULT_PRECIS 0
  &GLOB CLIP_DEFAULT_PRECIS 0
  &GLOB PROOF_QUALITY 2
  &GLOB FIXED_PITCH 1
  &GLOB VARIABLE_PITCH 2
  &GLOB FF_DONTCARE 0

  &GLOB DM_OUT_BUFFER 2
  &GLOB DM_IN_BUFFER 8
  &GLOB CCHDEVICENAME 32
  &GLOB DM_ORIENTATION 1
  &GLOB DM_PAPERSIZE	2
  &GLOB DM_PAPERLENGTH 4
  &GLOB DM_PAPERWIDTH 8
  &GLOB DM_COPIES 256
  
  &GLOB DMORIENT_LANDSCAPE 2
  &GLOB DMORIENT_PORTRAIT 1

/* paper sizes */
  &GLOB DMPAPER_FIRST       1           /* first paper size                   */
  &GLOB DMPAPER_LETTER      1           /* Letter 8 1/2 x 11 in               */
  &GLOB DMPAPER_LETTERSMALL 2           /* Letter Small 8 1/2 x 11 in         */
  &GLOB DMPAPER_TABLOID     3           /* Tabloid 11 x 17 in                 */
  &GLOB DMPAPER_LEDGER      4           /* Ledger 17 x 11 in                  */
  &GLOB DMPAPER_LEGAL       5           /* Legal 8 1/2 x 14 in                */
  &GLOB DMPAPER_STATEMENT   6           /* Statement 5 1/2 x 8 1/2 in         */
  &GLOB DMPAPER_EXECUTIVE   7           /* Executive 7 1/4 x 10 1/2 in        */
  &GLOB DMPAPER_A3          8           /* A3 297 x 420 mm                    */
  &GLOB DMPAPER_A4          9           /* A4 210 x 297 mm                    */
  &GLOB DMPAPER_A4SMALL     10          /* A4 Small 210 x 297 mm              */
  &GLOB DMPAPER_A5          11          /* A5 148 x 210 mm                    */
  &GLOB DMPAPER_B4          12          /* B4 250 x 354                       */
  &GLOB DMPAPER_B5          13          /* B5 182 x 257 mm                    */
  &GLOB DMPAPER_FOLIO       14          /* Folio 8 1/2 x 13 in                */
  &GLOB DMPAPER_QUARTO      15          /* Quarto 215 x 275 mm                */
  &GLOB DMPAPER_10X14       16          /* 10x14 in                           */
  &GLOB DMPAPER_11X17       17          /* 11x17 in                           */
  &GLOB DMPAPER_NOTE        18          /* Note 8 1/2 x 11 in                 */
  &GLOB DMPAPER_ENV_9       19          /* Envelope #9 3 7/8 x 8 7/8          */
  &GLOB DMPAPER_ENV_10      20          /* Envelope #10 4 1/8 x 9 1/2         */
  &GLOB DMPAPER_ENV_11      21          /* Envelope #11 4 1/2 x 10 3/8        */
  &GLOB DMPAPER_ENV_12      22          /* Envelope #12 4 \276 x 11           */
  &GLOB DMPAPER_ENV_14      23          /* Envelope #14 5 x 11 1/2            */
  &GLOB DMPAPER_CSHEET      24          /* C size sheet                       */
  &GLOB DMPAPER_DSHEET      25          /* D size sheet                       */
  &GLOB DMPAPER_ESHEET      26          /* E size sheet                       */
  &GLOB DMPAPER_ENV_DL      27          /* Envelope DL 110 x 220mm            */
  &GLOB DMPAPER_ENV_C5      28          /* Envelope C5 162 x 229 mm           */
  &GLOB DMPAPER_ENV_C3      29          /* Envelope C3  324 x 458 mm          */
  &GLOB DMPAPER_ENV_C4      30          /* Envelope C4  229 x 324 mm          */
  &GLOB DMPAPER_ENV_C6      31          /* Envelope C6  114 x 162 mm          */
  &GLOB DMPAPER_ENV_C65     32          /* Envelope C65 114 x 229 mm          */
  &GLOB DMPAPER_ENV_B4      33          /* Envelope B4  250 x 353 mm          */
  &GLOB DMPAPER_ENV_B5      34          /* Envelope B5  176 x 250 mm          */
  &GLOB DMPAPER_ENV_B6      35          /* Envelope B6  176 x 125 mm          */
  &GLOB DMPAPER_ENV_ITALY   36          /* Envelope 110 x 230 mm              */
  &GLOB DMPAPER_ENV_MONARCH 37          /* Envelope Monarch 3.875 x 7.5 in    */
  &GLOB DMPAPER_ENV_PERSONAL 38         /* 6 3/4 Envelope 3 5/8 x 6 1/2 in    */
  &GLOB DMPAPER_FANFOLD_US   39         /* US Std Fanfold 14 7/8 x 11 in      */
  &GLOB DMPAPER_FANFOLD_STD_GERMAN  40  /* German Std Fanfold 8 1/2 x 12 in   */
  &GLOB DMPAPER_FANFOLD_LGL_GERMAN  41  /* German Legal Fanfold 8 1/2 x 13 in */

/* NIKI begin */
PROCEDURE GetTextExtentPoint32A external "gdi32":
    DEFINE INPUT PARAMETER hdc as long. 
    DEFINE INPUT PARAMETER lpString as character. 
    DEFINE INPUT PARAMETER cbString as long. 
    DEFINE INPUT PARAMETER lpSize as memptr.  
    DEFINE RETURN PARAMETER is-OK as short. 
END PROCEDURE.
/* NIKI end */

PROCEDURE CreateDCA EXTERNAL "gdi32" :
  DEFINE INPUT  PARAMETER lpszDriver   AS CHARACTER.
  DEFINE INPUT  PARAMETER lpszDevice   AS CHARACTER.
  DEFINE INPUT  PARAMETER lpszOutput   AS long.
  DEFINE INPUT  PARAMETER lpInitData   AS long.
  DEFINE RETURN PARAMETER hDC          AS long.
END PROCEDURE.
 
PROCEDURE DeleteDC EXTERNAL "gdi32" :
   DEFINE INPUT  PARAMETER hdc         AS LONG.
   DEFINE RETURN PARAMETER ReturnValue AS LONG.
END PROCEDURE.

PROCEDURE DocumentPropertiesA EXTERNAL "winspool.drv" :
  DEFINE INPUT  PARAMETER HWND           AS LONG.
  DEFINE INPUT  PARAMETER hPrinter       AS LONG.
  DEFINE INPUT  PARAMETER pDeviceName    AS CHARACTER.
  DEFINE INPUT  PARAMETER pDevmodeOutput AS LONG.
  DEFINE INPUT  PARAMETER pDevmodeInput  AS LONG.
  DEFINE INPUT  PARAMETER fMode          AS LONG.
  DEFINE RETURN PARAMETER ReturnValue    AS LONG.
END PROCEDURE.

PROCEDURE GetProfileStringA EXTERNAL "kernel32" :
  DEFINE INPUT  PARAMETER lpAppName        AS CHAR.
  DEFINE INPUT  PARAMETER lpKeyName        AS CHAR.
  DEFINE INPUT  PARAMETER lpDefault        AS CHAR.
  DEFINE OUTPUT PARAMETER lpReturnedString AS CHAR.
  DEFINE INPUT  PARAMETER nSize            AS LONG.
  DEFINE RETURN PARAMETER nReturnedChars   AS LONG.
END PROCEDURE.
 
PROCEDURE StartDocA EXTERNAL "gdi32" :
  DEFINE INPUT  PARAMETER hdc   AS LONG.
  DEFINE INPUT  PARAMETER lpdi  AS LONG.
  DEFINE RETURN PARAMETER JobId AS LONG.
END PROCEDURE.
 
PROCEDURE EndDoc EXTERNAL "gdi32" :
  DEFINE INPUT  PARAMETER hdc         AS LONG.
  DEFINE RETURN PARAMETER ReturnValue AS LONG.
END PROCEDURE.
 
PROCEDURE StartPage EXTERNAL "gdi32" :
  DEFINE INPUT  PARAMETER hdc         AS LONG.
  DEFINE RETURN PARAMETER ReturnValue AS LONG.
END PROCEDURE.
 
PROCEDURE EndPage EXTERNAL "gdi32" :
  DEFINE INPUT  PARAMETER hdc         AS LONG.
  DEFINE RETURN PARAMETER ReturnValue AS LONG.
END PROCEDURE.
 
PROCEDURE TextOutA EXTERNAL "gdi32" :
  DEFINE INPUT  PARAMETER hdc         AS LONG.
  DEFINE INPUT  PARAMETER nXstart     AS LONG.
  DEFINE INPUT  PARAMETER nYstart     AS LONG.
  DEFINE INPUT  PARAMETER lpString    AS CHAR.
  DEFINE INPUT  PARAMETER cbString    AS LONG.
  DEFINE RETURN PARAMETER ReturnValue AS LONG.
END PROCEDURE.
 
PROCEDURE SetTextAlign EXTERNAL "gdi32" :
  DEFINE INPUT  PARAMETER hdc           AS LONG.
  DEFINE INPUT  PARAMETER fMode         AS LONG.
  DEFINE RETURN PARAMETER fPreviousMode AS LONG.
END PROCEDURE.
 
PROCEDURE GetDeviceCaps EXTERNAL "GDI32" :
   DEFINE INPUT  PARAMETER hdc    AS LONG.
   DEFINE INPUT  PARAMETER nIndex AS LONG.
   DEFINE RETURN PARAMETER dwCaps AS LONG.
END PROCEDURE.
 
PROCEDURE MoveToEx EXTERNAL "gdi32" :
   DEFINE INPUT  PARAMETER hdc         AS LONG.
   DEFINE INPUT  PARAMETER X           AS LONG.
   DEFINE INPUT  PARAMETER Y           AS LONG.
   DEFINE INPUT  PARAMETER lpPoint     AS LONG.
   DEFINE RETURN PARAMETER ReturnValue AS LONG.
END PROCEDURE.
 
PROCEDURE LineTo EXTERNAL "gdi32" :
   DEFINE INPUT  PARAMETER hdc         AS LONG.
   DEFINE INPUT  PARAMETER X           AS LONG.
   DEFINE INPUT  PARAMETER Y           AS LONG.
   DEFINE RETURN PARAMETER ReturnValue AS LONG.
END PROCEDURE.
 
PROCEDURE SelectObject EXTERNAL "gdi32" :
   DEFINE INPUT  PARAMETER hdc         AS LONG.
   DEFINE INPUT  PARAMETER hgdiobj     AS LONG.
   DEFINE RETURN PARAMETER ReturnValue AS LONG.
END PROCEDURE.
 
PROCEDURE DeleteObject EXTERNAL "gdi32" :
   DEFINE INPUT  PARAMETER hObject     AS LONG.
   DEFINE RETURN PARAMETER ReturnValue AS LONG.
END PROCEDURE.
 
PROCEDURE GetTextMetricsA EXTERNAL "gdi32" :
  DEFINE INPUT  PARAMETER hdc         AS LONG.
  DEFINE INPUT  PARAMETER lpTm        AS LONG.
  DEFINE RETURN PARAMETER ReturnValue AS LONG.
END PROCEDURE.
 
PROCEDURE CreateFontA EXTERNAL "gdi32" :
  DEFINE INPUT  PARAMETER nHeight            AS LONG.
  DEFINE INPUT  PARAMETER nWidth             AS LONG.
  DEFINE INPUT  PARAMETER nEscapement        AS LONG.
  DEFINE INPUT  PARAMETER nOrientation       AS LONG.
  DEFINE INPUT  PARAMETER fnWeight           AS LONG.
  DEFINE INPUT  PARAMETER fdwItalic          AS LONG.
  DEFINE INPUT  PARAMETER fdwUnderline       AS LONG.
  DEFINE INPUT  PARAMETER fdwStrikeOut       AS LONG.
  DEFINE INPUT  PARAMETER fdwCharSet         AS LONG.
  DEFINE INPUT  PARAMETER fdwOutputPrecision AS LONG.
  DEFINE INPUT  PARAMETER fdwClipPrecision   AS LONG.
  DEFINE INPUT  PARAMETER fdwQuality         AS LONG.
  DEFINE INPUT  PARAMETER fdwPitchAndFamily  AS LONG.
  DEFINE INPUT  PARAMETER lpszFace           AS CHAR.
  DEFINE RETURN PARAMETER hFont              AS LONG.
END PROCEDURE.
 
PROCEDURE MulDiv EXTERNAL "kernel32" :
  DEFINE INPUT  PARAMETER nNumber      AS LONG.
  DEFINE INPUT  PARAMETER nNumerator   AS LONG.
  DEFINE INPUT  PARAMETER nDenominator AS LONG.
  DEFINE RETURN PARAMETER ReturnValue  AS LONG.
END PROCEDURE.


